include image.e     
include get.e
include graphics.e
include menu_eng.e
--without type_check
--------------------------------------------------------------------------------
--   * PUWT v1.0 *                            L.Ral Campos Arribas (c) 1998
--   (Pop_Up_Window Toolkit)
--    my address ===========================> 95203695@xaee.ub.es
--   
--   This is my first release of PUWT.Therefore,please report any bugs,
--   send me comments,suggestions,ideas or whatever you want!
--      This is a good alternative for those who just want a nice
--   text mode menu and don't want to blast off the size of their programs 
--   including David Cuny's great Text_gui routines. 

--   Thanks to: 

--          * Daniel Bernstain for his MENU_ENG.E routine
--            (i added the function clock&date to your code!)
--          * David Cuny for his powerfull TEXT_GUI package
--          * R.D.S for creating EUPHORIA ;-)
--          * University of Barcelona(Pharmacy teachment)
--            for my e-mail address and internet support 

--    ****** Use it as you wish and at your own risk !!! ******
--           
--                  I'll be back.Sure!!! :)
--------------------------------------------------------------------------------

sequence orig_screen, sombra_dialog, row, pattern,
         Item_List, parameters, String_List,
         clock_parameters, Date_parameters

integer selection

-----------------------------------------------------------------------------
--                  { { Y, X }, { Background color, Text_color } }

 clock_parameters = { { 25, 75 }, { BLUE, BRIGHT_WHITE } } ---> User
 Date_parameters = { { 25, 2 }, { BLUE, BRIGHT_WHITE } } ---> modifiable
-----------------------------------------------------------------------------

global constant window = { 
                           {  
                            { 218, 196, 191 },
                            { 179, " ", 179 },
                            { 192, 196, 217 }
                           },
                           {
                            { 201, 205, 187 },
                            { 186, " ", 186 },
                            { 200, 205, 188 }
                           },
                           {
                            { " ", " ", " " },
                            { " ", " ", " " },  
                            { " ", " ", " " }  
                           }
                          }                         

-----------------------------------------------------------------------------

global procedure pop_up_window( sequence top_left, sequence top_right,
                         sequence bot_left, sequence bot_right,
                         integer marco, sequence colors,
                         integer modo
                       )
  ---
  ---  top_left = { y, x }
  ---  modo = 0,1
  ---  marco = 1,2,3
  ---  colors = { Background, Frame color }
  ---
orig_screen = save_text_image( 
                              {top_left[1],top_left[2]},
                              {bot_right[1] + 1,bot_right[2] + 2}
                             )

sombra_dialog = save_text_image( 
                                {top_left[1] + 1, top_left[2] + 1},
                                {bot_right[1] + 1, bot_right[2] + 2} 
                               )

for x = 1 to length( sombra_dialog ) do
      for n = 2 to length( sombra_dialog[x] ) by 2 do
          sombra_dialog[x][n] = BLACK + GRAY
      end for
end for

if modo = 1 then

   display_text_image( { top_left[1] + 1, top_left[2] + 1 }, sombra_dialog )

end if 


row = {}         

for x = top_left[2] + 1 to top_right[2] do
    row = row & " "     
end for
text_color( colors[2] )
  bk_color( colors[1] )
 
 for y = top_left[1] to bot_left[1] do
         position( y, top_left[2] )
         puts( 1, row )
 end for         
 
 for x = top_left[2] + 1 to top_right[2] - 1 do
     position( top_left[1], x )
         puts( 1, window[marco][1][2] )       
     position( bot_left[1], x )                      
         puts( 1, window[marco][1][2] )
 end for
 
 for y = top_left[1] + 1 to bot_right[1] - 1 do
     position( y, top_left[2] )
         puts( 1, window[marco][2][1] )
     position( y, top_right[2] )
         puts( 1, window[marco][2][3] )
 end for
          
 position( top_left[1], top_left[2] )
     puts( 1, window[marco][1][1] )
 position( top_right[1], top_right[2] )
      puts( 1, window[marco][1][3] )
 position( bot_right[1], bot_right[2] )      
     puts( 1, window[marco][3][3] )
 position( bot_left[1], bot_left[2] )
     puts( 1, window[marco][3][1] )
end procedure
-----------------------------------------------------------------------------        

global procedure desktop( integer code, sequence colors )
          text_color(colors[1])
          bk_color(colors[2])
  clear_screen()
  pattern = repeat( code, 80 )
  for y = 1 to 25 do
      position( y, 1 )
      puts( 1, pattern )
  end for

end procedure

-----------------------------------------------------------------------------
global function Text_Window( sequence Text_Strings,
                             sequence Position,
                             sequence Colors,
                             sequence Options,
                             integer Lines
                            )    
--  Text_Strings = { "string #1", "string #2", "string #3"... }
--
--  Position = { top_left_Y, top_left_X } ---->Left corner of the window
--
--  Colors = { Text_Color, 
--             Window_Color, 
--             Frame_Text_Color }
--
----
--  Options = { Shadow, Frame, Clock & Date , Refresh }

--                              ----> 0 = without shadow
--                                    1 = with shadow        
--                              ----> 1 = with single line frame  
--                                    2 = with double line frame
--                                    3 = without frame in the window
--                              ----> 0 = without clock and date display    
--                                    1 = with clock and date
--                              ----> 0 = no refresh
--                                    1 = refresh the window     
--   Lines = the number of lines that you want to diplay at once in
--           the text window

 String_List = repeat( "", length( Text_Strings ) )
 for n = 1 to length( Text_Strings ) do
         String_List[n] = Text_Strings[n]
 end for

--  String_List = { "   string #1   ", 
--                  "          #2   ",        
--                  "          #3   ", 
--                  "          #4   ",
--                  "          #5   ",
--                  ....................
--                  "   string #n   " }   
--
-- Note: The strings inside sequence String_List does'nt need to have 
--       the same length ( > 0 ) including the blank gaps.You will have 
--       to justify the text manually!

pop_up_window( 
  { Position[1], Position[2] }, 
  { Position[1], Position[2] + length(String_List[1]) + 1 },
  { Position[1] + length(String_List) + 1, Position[2]}, 
  { Position[1] + length(String_List) + 1, 
                                        Position[2] + length(String_List[1])+1}
  , Options[2], { Colors[2], Colors[3] }, Options[1] )
  ---
  ---  top_left = { y, x }....
  ---  modo = 0,1
  ---  marco = 1,2,3
  ---  colors = { Background, Frame_text }
  ---
  parameters = {}
  parameters = repeat(0, 7)
  parameters[1] = Position[1] + 1         -- Starting row coord.
  parameters[2] = Position[2] + 1         -- Starting column coord.
  parameters[3] = length(Item_List) / 1   -- Maximum column length
  parameters[4] = length(Item_List[1])    -- Column width
  parameters[5] = 1                       -- Number of visible columns
  parameters[6] = 1                       -- Complete lightbar style
  parameters[7] = 0                       -- without scrollbar display
cursor(NO_CURSOR)
selection = menu( 
                  String_List, parameters, 
                  { Colors[1], Colors[2], Colors[1], Colors[2] },
                  Options[3],
                  clock_parameters, Date_parameters
                )     

if selection != -1 and Options[1] != 0 and Options[4] = 1 then
    display_text_image( { Position[1] + 1, Position[2] + 1 }, sombra_dialog )
    display_text_image( { Position[1], Position[2] }, orig_screen ) 
elsif selection != -1 and Options[1] = 0 and Options[4] = 0 then
    display_text_image( { Position[1], Position[2] }, orig_screen ) 
 end if   
    
    return selection



end function

global function Menu_Window( sequence Menu_Items, 
                             sequence Position, 
                             sequence Colors,
                             sequence Options
                           )

--  Menu_Items = { "Item #1", "Item #2", "Item #3"... }
--
--  Position = { top_left_Y, top_left_X } ---->Left corner of the window
--
--  Colors = { Text_Color, 
--             Window_Color, 
--             Frame_Text_Color,
--             Bar_Color, 
--             Bar_Text_Color }
--
--  Options = { Shadow, Frame, Clock & Date , Refresh }

--                              ----> 0 = without shadow
--                                    1 = with shadow        
--                              ----> 1 = with single line frame  
--                                    2 = with double line frame
--                                    3 = without frame in the window
--                              ----> 0 = without clock and date display    
--                                    1 = with clock and date
--                              ----> 0 = no refresh
--                                    1 = refresh the window     
 Item_List = repeat( "", length( Menu_Items ) )
 for n = 1 to length( Menu_Items ) do
         Item_List[n] = Menu_Items[n]
 end for

--  Item_List = { "   Menu_Item #1   ", 
--                "   Menu_Item #2   ",        
--                "   Menu_Item #3   ", 
--                "   Menu_Item #4   ",
--                "   Menu_Item #5   ",
--                ....................
--                "   Menu_Item #n   " }   
--
-- Note: All the elements inside squence Item_List must have the same
--       length ( > 0 ).You will have to justify the text manually!

pop_up_window( 
  { Position[1], Position[2] }, 
  { Position[1], Position[2] + length(Item_List[1]) + 1 },
  { Position[1] + length(Item_List) + 1, Position[2]}, 
  { Position[1] + length(Item_List) + 1, Position[2] + length(Item_List[1])+1}
  , Options[2], { Colors[2], Colors[3] }, Options[1] )
  ---
  ---  top_left = { y, x }....
  ---  modo = 0,1
  ---  marco = 1,2,3
  ---  colors = { Background, Frame_text }
  ---
  parameters = {}
  parameters = repeat(0, 7)
  parameters[1] = Position[1] + 1         -- Starting row coord.
  parameters[2] = Position[2] + 1         -- Starting column coord.
  parameters[3] = length(Item_List) / 1   -- Maximum column length
  parameters[4] = length(Item_List[1])    -- Column width
  parameters[5] = 1                       -- Number of visible columns
  parameters[6] = 1                       -- Complete lightbar style
  parameters[7] = 0                       -- without scrollbar display

selection = menu( 
                  Item_List, parameters, 
                  { Colors[1], Colors[2], Colors[5], Colors[4] },
                  Options[3],
                  clock_parameters, Date_parameters
                )     

if selection != -1 and Options[1] != 0 and Options[4] = 1 then
    display_text_image( { Position[1] + 1, Position[2] + 1 }, sombra_dialog )
    display_text_image( { Position[1], Position[2] }, orig_screen ) 
elsif selection != -1 and Options[1] = 0 and Options[4] = 0 then
    display_text_image( { Position[1], Position[2] }, orig_screen ) 
 end if   
    
    return selection
end function


